#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#define min(A,B) ((A)<(B)?(A):(B))
#define max(A,B) ((A)>(B)?(A):(B))
FILE *fopene(char *filename, char *rw, char *err);
char get_param(int *k, char **arg, char *value);
int names_infile(FILE *infile, char (**names)[11], int sequential);
void read_treecsnl(FILE *treefile, int ntaxa, char names[][11], double *utreec, 
		   int has_names);
void treecsnl(int ntaxa, char *tstr, char names[][11], double *utreec, 
	      int has_names);
int read_tree(FILE *fp, char *tstring);
int ntrees_treefile(FILE *treefile);
char **treecs(int ntaxa, char *tstr, char names[][11], double *utreec, 
	      int has_names);
double get_dlist(char *tstr, int ss, int de, int *ssn, int *ls, int *le);
void rmexspce(int numsp, char names[][11]);
int ndig_intpart(double f);
char *ut2in(int numsp, double *utreec, char names[][11], char **ilabels);
void pr_tstr_labels(FILE *otreefile, int ntaxa, double *utreec, 
		    char names[][11]);
void split_leading1(int numsp, int *split);
void utreec2splits(int numsp, double *utreec, int *splits);
int nrow_ftaxa_file(FILE *infile);
int check_split_ftaxa(int *split, int *ftaxat);
void utreec2du(int ntaxa, double *utreec, int *du);
void du2fgp(int ntaxa, double *utreec, int *du);
void reorder_ftaxa(int i, int j, int k, int l, int *t);
int du2ftaxa(int ntaxa, double *utreec, int *du, int *ftaxa);
int boot4taxa(FILE *treefile, int ntaxa, char names[][11], int B, int *ftaxa);
void bpftaxa(int ntaxa, int nftb, int *ftaxab, int nft, int *ftaxat);
int lstring(char * string);
int isamev(int n, int *a, int inca, int *b, int incb);
