#include "phylo-stability.h"
int main(int argc, char **argv)
{
  FILE *treefile;
  char (*names)[11];
  int ntaxa,has_names;
  double *utreec;
  
  ntaxa=atoi(argv[--argc]);
  treefile=fopen(argv[--argc],"r");

  if (ntaxa > 0){
    names=(char (*)[11]) malloc((size_t) ntaxa*sizeof(*names));
    has_names=0;
  }
  else{
    ntaxa=names_infile(stdin,&names,0);
    has_names=1;
  }
  utreec=(double *)malloc(4*ntaxa*sizeof(double));
  read_treecsnl(treefile,ntaxa,names,utreec,has_names);
  
  pr_tstr_labels(stdout,ntaxa,utreec,names);
  return(0);
}
